#include <stdio.h>
#include <math.h>
#include <vector>
#include <algoritm>
using namespace std;

#define HRange 100000

struct Point {
   int X,Y,Z;
};

int Seg[4000][2];
double SegTime[4000];
double SegLen[4000];
struct Point Latice[4000];
double EndT[2000][2];
int Hash[HRange];
int NextH[4000];
int LP;
int LaticeSeg[4000][4000];
int LaticeSegN[4000];

int HFce(int X,int Y,int Z) {
   return (X*31+Y*12384+(Z^318276))%HRange;
};

double sqr(double x) {
	return x*x;
};

int FindPoint(int X,int Y,int Z) {
	int H;
	int Pos,Last;

	H = HFce(X,Y,Z);
	Pos = Hash[H];
	Last = -1;
	while (Pos != -1) {
		if ((X == Latice[Pos].X) && (Y == Latice[Pos].Y) && (Z == Latice[Pos].Z)) return Pos;
		Last = Pos;
		Pos = NextH[Pos];
	};
	Latice[LP].X = X;
	Latice[LP].Y = Y;
	Latice[LP].Z = Z;
	if (Last == -1) {
		Hash[H] = LP;
	} else {
		NextH[Last] = LP;
	};
	NextH[LP++]=-1;
	return (LP-1);
};

int main() {
	int i,j;
	int N,S,T;
	int Xf,Yf,Zf,Xt,Yt,Zt;
	int X1,Y1,Z1,X2,Y2,Z2;
	int St,En,P1,P2,SegN;
	double Len;
	
	while (scanf("%d%d%d",&N,&S,&T) == 3) {
		for (i=0;i<HRange;i++) {
			Hash[i]=-1;
		};
		LP = 0;
		SegN = 0;
		scanf("%d%d%d%d%d%d",&Xf,&Yf,&Zf,&Xt,&Yt,&Zt);
		St = FindPoint(Xf,Yf,Zf);
		En = FindPoint(Xt,Yt,Zt);
//printf("%d %d\n",St,En);
		for (i=0;i<N;i++) {
			scanf("%d%d%d%d%d%d",&X1,&Y1,&Z1,&X2,&Y2,&Z2);
			P1 = FindPoint(X1,Y1,Z1);
			P2 = FindPoint(X2,Y2,Z2);
//printf("%d, %d %d\n",i,P1,P2);
			Len = sqrt(sqr(X1-X2)+sqr(Y1-Y2)+sqr(Z1-Z2));
			SegLen[SegN]=Len;
			Seg[SegN][0]=P1;
			Seg[SegN++][1]=P2;
			SegLen[SegN]=Len;
			Seg[SegN][0]=P2;
			Seg[SegN++][1]=P1;
		};
		for (i=0;i<LP;i++) LaticeSegN[i]=0;
		for (i=0;i<SegN;i++) {
			P1 = Seg[i][0];
			LaticeSeg[P1][LaticeSegN[P1]++]=i;
		};
/*for (i=0;i<LP;i++) {
	printf("%d - ",LaticeSegN[i]);
	for (j=0;j<LaticeSegN[i];j++) printf("%d ",LaticeSeg[i][j]);
	printf("\n");		
}*/
		if (St == En) {
			printf("0.000\n");
		} else {

			printf("\n");
		};
	};
	return 0;
};
